commit 8b8b9b2e2f1f45bf44b78b2b9ac4bca4a2a3c2ac
Author: Katja Luther <k.luther@bgbm.org>
Date:   Tue May 29 10:23:21 2018 +0200

    some changes for the admin preferences

diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
index 26a7cdf4a..0cf7499ed 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
@@ -191,4 +191,5 @@ page.name.44 = Name Details
 extension-point.name = Cdm Viewer
 extension-point.name.0 = Preference Page
 extension-point.name.1 = Admin Preference Page
-page.name.45 = Specimen Preferences
\ No newline at end of file
+page.name.45 = Specimen Preferences
+page.name.46 = Publish Flag Preferences
\ No newline at end of file
diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
index 013d37710..1b092ebff 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
@@ -191,4 +191,6 @@ page.name.44 = Detailsview f
 extension-point.name = Cdm Viewer
 extension-point.name.0 = Präferenzen
 extension-point.name.1 = Admin Präferenzen
-page.name.45 = Specimen Präferenzen
\ No newline at end of file
+page.name.45 = Specimen Präferenzen
+page.name.46 = Publish Flag Präferenzen
+1
\ No newline at end of file
diff --git a/eu.etaxonomy.taxeditor.store/plugin.xml b/eu.etaxonomy.taxeditor.store/plugin.xml
index e693d7d3b..25d191d62 100755
--- a/eu.etaxonomy.taxeditor.store/plugin.xml
+++ b/eu.etaxonomy.taxeditor.store/plugin.xml
@@ -598,11 +598,16 @@
    </page>
    <page
         
-         class="eu.etaxonomy.taxeditor.databaseAdmin.preferencePage.PublishFlagPreference"
+         class="eu.etaxonomy.taxeditor.databaseAdmin.preferencePage.GeneralAdminPreferencePage"
          id="eu.etaxonomy.taxeditor.preferences.general"
          name="%page.name.42">
    </page>
-   
+    <page
+        category="eu.etaxonomy.taxeditor.preferences.general"
+         class="eu.etaxonomy.taxeditor.databaseAdmin.preferencePage.PublishFlagPreference"
+         id="eu.etaxonomy.taxeditor.preferences.publishFlagPreference"
+         name="%page.name.46">
+   </page>
    <page
          category="eu.etaxonomy.taxeditor.preferences.general"
          class="eu.etaxonomy.taxeditor.databaseAdmin.preferencePage.NomenclaturalCodePreferences"
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/GeneralAdminPreferencePage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/GeneralAdminPreferencePage.java
new file mode 100755
index 000000000..7659c2eaf
--- /dev/null
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/GeneralAdminPreferencePage.java
@@ -0,0 +1,43 @@
+/**
+* Copyright (C) 2018 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;
+
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+
+import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;
+
+/**
+ * @author k.luther
+ * @since 29.05.2018
+ *
+ */
+public class GeneralAdminPreferencePage extends CdmPreferencePage implements IE4AdminPreferencePage {
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    protected Control createContents(Composite parent) {
+        final Composite composite = new Composite(parent, SWT.NULL);
+
+        GridLayout gridLayout = new GridLayout();
+        composite.setLayout(gridLayout);
+        return composite;
+    }
+
+    @Override
+    public void createControl(Composite parent){
+        super.createControl(parent);
+        getControl().setVisible(false);
+    }
+
+}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/SpecimenAdminPreferences.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/SpecimenAdminPreferences.java
index 03fb98770..4257f1c18 100755
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/SpecimenAdminPreferences.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/SpecimenAdminPreferences.java
@@ -12,6 +12,7 @@ import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.SelectionAdapter;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Control;
@@ -45,7 +46,8 @@ public class SpecimenAdminPreferences extends CdmPreferencePage implements IE4Ad
     @Override
     protected Control createContents(Composite parent) {
         Composite composite = new Composite(parent, SWT.NULL);
-
+        GridLayout gridLayout = new GridLayout();
+        composite.setLayout(gridLayout);
         final Button showCollectingAreaInGeneralSectionButton = new Button(composite, SWT.CHECK);
 
         showCollectingAreaInGeneralSectionButton.setText(Messages.DatabasePreferncesPage_Show_Collecting_Areas_in_general_section);